/*===========================================================================
/
/									ttPage
/							sԍ\\EChE
/
/============================================================================
/ Copyright (C) 1998-2007 Sota. All rights reserved.
/
/ Redistribution and use in source and binary forms, with or without 
/ modification, are permitted provided that the following conditions 
/ are met:
/
/  1. Redistributions of source code must retain the above copyright 
/     notice, this list of conditions and the following disclaimer.
/  2. Redistributions in binary form must reproduce the above copyright 
/     notice, this list of conditions and the following disclaimer in the 
/     documentation and/or other materials provided with the distribution.
/
/ THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
/ IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
/ OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
/ IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, 
/ INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
/ BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
/ USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
/ ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
/ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/ THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/============================================================================*/

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windowsx.h>
#include <commctrl.h>
#include <tchar.h>

#include "common.h"
#include "resource.h"


/*===== vg^Cv =====*/

static LRESULT CALLBACK NumWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
static void RePaintNum(HWND hWnd);
static void DispLineNum(HWND hWnd, HDC hDC, int top, int btm);

/*===== [Jȃ[N =====*/

static const _TCHAR NumClassStr[] = _T("ttPageNumClass");
static HWND hWndNum = NULL;
static int NumWinWidth;

/*===== OQ =====*/

extern HFONT hFontttPage;
extern int LineNum;


/*-------------------------------------------------------------------------------
Name    :	MakeNumWindow
Desc    :	sԍEChE쐬
Param   :	hWnd	eEChẼEChEnh
Return  :	Xe[^X (SUCCESS/FAIL)
Note    :	
-------------------------------------------------------------------------------*/
int MakeNumWindow(HWND hWnd)
{
	WNDCLASSEX	wClass;
	RECT		rect;
	int			sts;

	sts = FAIL;
	wClass.cbSize        = sizeof(WNDCLASSEX);
	wClass.style         = 0;
	wClass.lpfnWndProc   = NumWndProc;
	wClass.cbClsExtra    = 0;
	wClass.cbWndExtra    = 0;
	wClass.hInstance     = GetProgInst();
	wClass.hIcon         = NULL;
	wClass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wClass.hbrBackground = NULL;
	wClass.lpszMenuName  = NULL;
	wClass.lpszClassName = NumClassStr;
	wClass.hIconSm       = NULL;
	RegisterClassEx(&wClass);

	GetClientRect(hWnd, &rect);

	hWndNum = CreateWindow(NumClassStr, _T(""),
				WS_CHILD | WS_BORDER,
				0, GetToolBarHeight(), AskNumWinWidth()+1, rect.bottom - GetStatusWinHeight() - GetToolBarHeight() - GetSystemMetrics(SM_CYHSCROLL),
				hWnd, (HMENU)1500, GetProgInst(), NULL);

	if(hWndNum != NULL)
	{
		ShowWindow(hWndNum, SW_SHOW);
		sts = SUCCESS;
	}

	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	DeleteNumWindow
Desc    :	sԍEChE폜
Param   :	none
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void DeleteNumWindow(void)
{
	UnregisterClass(NumClassStr, GetProgInst());
	return;
}


/*-------------------------------------------------------------------------------
Name    :	GetNumWinHwnd
Desc    :	sԍEChẼEChEnhԂ
Param   :	none
Return  :	EChEnh
Note    :	
-------------------------------------------------------------------------------*/
HWND GetNumWinHwnd(void)
{
	return(hWndNum);
}


/*-------------------------------------------------------------------------------
Name    :	ResizeNumWindow
Desc    :	sԍEChẼTCYύX̏
Param   :	none
Return  :	none
Note    :	CEChEc[o[^Xe[^Xo[r[EChE
			ŃTCYύX邱
-------------------------------------------------------------------------------*/
void ResizeNumWindow(void)
{
	RECT	rect;

	GetClientRect(GetMainHwnd(), &rect);
	SetWindowPos(hWndNum, NULL, 
		0, 
		GetToolBarHeight(), 
		AskNumWinWidth()+1, 
		rect.bottom - GetStatusWinHeight() - GetToolBarHeight() - GetSystemMetrics(SM_CYHSCROLL),
		SWP_NOACTIVATE | SWP_NOZORDER | SWP_NOMOVE);
	return;
}


/*-------------------------------------------------------------------------------
Name    :	NumWndProc
Desc    :	sԍEChẼbZ[W
			hWnd	EChEnh
			message	bZ[Wԍ
			wParam	bZ[W WPARAM 
			lParam	bZ[W LPARAM 
Param   :	
Return  :	LRESULT
Note    :	
-------------------------------------------------------------------------------*/
static LRESULT CALLBACK NumWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_PAINT :
			RePaintNum(hWnd);
			break;

		default :
			return(DefWindowProc(hWnd, message, wParam, lParam));
	}
    return(0L);
}


/*-------------------------------------------------------------------------------
Name    :	RePaintNum
Desc    :	WM_PAINT̏
Param   :	hWnd		EChEnh
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void RePaintNum(HWND hWnd)
{
	PAINTSTRUCT		ps;
	RECT			rect;

    BeginPaint(hWnd, (LPPAINTSTRUCT) &ps);

	GetClientRect(hWnd, &rect);

	if(AskCurFileTbl() != NULL)
	{
		DispLineNum(hWnd, ps.hdc, 0, (rect.bottom - rect.top + AskCharCellHeight() - 1) / AskCharCellHeight());
	}
	else
	{
		FillRect(ps.hdc, &rect, AskViewBackColor());
	}
    EndPaint(hWnd, (LPPAINTSTRUCT) &ps);
	return;
}


/*-------------------------------------------------------------------------------
Name    :	DispLineNum
Desc    :	sԍ\
Param   :	hWnd	EChEnh
			hDC		foCXReLXg(NULL=GetDCŋ߂)
			top		\擪sԍ
			btm		\sԍ
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
static void DispLineNum(HWND hWnd, HDC hDC, int top, int btm)
{
	HDC			inDC;
	HFONT		hFontOld;
	int			i;
	RECT		rect;
	FILEMANTBL	*curFile;
	_TCHAR		tmp[30];
	int			num;
	int			cellHeight;
	HBRUSH		backBrush;

	inDC = hDC;
	if(inDC == NULL)
	{
		hDC = GetDC(hWnd);
	}
	curFile = AskCurFileTbl();
	cellHeight = AskCharCellHeight();
	backBrush = AskViewBackColor();

	/* tHg */
	hFontOld = NULL;
	if(hFontttPage != NULL)
	{
		hFontOld = SelectObject(hDC, hFontttPage);
	}

	/* ̑ */
	GetClientRect(hWnd, &rect);
	SetBkMode(hDC, OPAQUE);
	SetTextColor(hDC, AskCurExtSet()->TextColor);
	SetBkColor(hDC, AskCurExtSet()->BackColor);
	SetTextAlign(hDC, TA_RIGHT);

	/* sԍ\郋[v */
	rect.top = top * cellHeight;
	rect.left = 0;
	for(i = top; i < btm; i++)
	{
		/* 炩ߏ */
		rect.bottom = rect.top + cellHeight;
		FillRect(hDC, &rect, backBrush);

		if((num = GetLogicalLineNum(curFile, curFile->DispTopLine + i)) != -1)
		{
			if(AskCurExtSet()->LineNumType == LINENUM_WP)
			{
				_stprintf(tmp, _T("%d"), curFile->DispTopLine + i + 1);
			}
			else
			{
				_stprintf(tmp, _T("%d"), num + 1);
			}
			rect.right -= LEFT_OFFSET;
			ExtTextOut(hDC, rect.right, rect.top, ETO_CLIPPED, &rect, tmp, _tcslen(tmp), NULL);
			rect.right += LEFT_OFFSET;
		}
		rect.top += cellHeight;
	}

	if(hFontOld != NULL)
	{
		SelectObject(hDC, hFontOld);
	}
	if(inDC == NULL)
	{
		ReleaseDC(hWnd, hDC);
	}

	return;
}


/*-------------------------------------------------------------------------------
Name    :	ScrollUpDownNum
Desc    :	㉺XN[
Param   :	num		XN[s
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void ScrollUpDownNum(int num)
{
	RECT	rect;
	RECT	upRect;
	HDC		hDC;

	hDC = GetDC(hWndNum);
	GetClientRect(hWndNum, &rect);
	ScrollDC(hDC, 0, num * AskCharCellHeight(), &rect, &rect, NULL, &upRect);
	ReleaseDC(hWndNum, hDC);

	RedrawWindow(hWndNum, &upRect, NULL, RDW_UPDATENOW | RDW_INVALIDATE | RDW_NOINTERNALPAINT);

	return;
}


/*-------------------------------------------------------------------------------
Name    :	CalcLineNumWinWidth
Desc    :	sԍEChẺvZ
Param   :	none
Return  :	none
Note    :	
-------------------------------------------------------------------------------*/
void CalcLineNumWinWidth(void)
{
	HFONT		hFontOld;
	FILEMANTBL	*curFile;
	_TCHAR		tmp[30];
	HDC			hDC;
	int			columns;
	SIZE		size;
	int			maxCx;
	int			i;

	hDC = GetDC(hWndNum);

	/* tHg */
	hFontOld = NULL;
	if(hFontttPage != NULL)
	{
		hFontOld = SelectObject(hDC, hFontttPage);
	}

	if(AskCurExtSet()->FoldRight == NO)
	{
		columns = 4;
		curFile = AskCurFileTbl();
		if(curFile != NULL)
		{
			_stprintf(tmp, _T("%d"), curFile->TextLines);
			columns = max(columns, (int)_tcslen(tmp));
		}
	}
	else
	{
		columns = 5;
	}

	maxCx = 0;
	for(i = 0; i <= 9; i++)
	{
		_stprintf(tmp, _T("%d"), i);
		GetTextExtentPoint32(hDC, tmp, 1, &size);
		maxCx = max(maxCx, size.cx);
	}
	NumWinWidth = columns * maxCx + LEFT_OFFSET * 2;

	if(hFontOld != NULL)
	{
		SelectObject(hDC, hFontOld);
	}

	ReleaseDC(hWndNum, hDC);

	return;
}


/*-------------------------------------------------------------------------------
Name    :	AskNumWinWidth
Desc    :	sԍEChẺԂ
Param   :	none
Return  :	
Note    :	int isԍ\Ȃ0j
-------------------------------------------------------------------------------*/
int AskNumWinWidth(void)
{
	return(NumWinWidth * LineNum);
}


