/*===========================================================================
/
/									ttPage
/								ChJ[h
/
/============================================================================
/ Copyright (C) 1998-2007 Sota. All rights reserved.
/
/ Redistribution and use in source and binary forms, with or without 
/ modification, are permitted provided that the following conditions 
/ are met:
/
/  1. Redistributions of source code must retain the above copyright 
/     notice, this list of conditions and the following disclaimer.
/  2. Redistributions in binary form must reproduce the above copyright 
/     notice, this list of conditions and the following disclaimer in the 
/     documentation and/or other materials provided with the distribution.
/
/ THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
/ IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
/ OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
/ IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, 
/ INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
/ BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
/ USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
/ ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
/ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/ THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/============================================================================*/

#define  STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <direct.h>
#include <windowsx.h>
#include <commctrl.h>

#include "common.h"


/*===== vg^Cv =====*/

static int CheckNameMatch(LPTSTR filename, LPTSTR exp);


/*-------------------------------------------------------------------------------
Name    :	CheckFnameWithArray
Desc    :	ChJ[hɃ}b`邩ǂԂ
Param   :	filename	t@C
			mulExp		ChJ[hi}`j
Return  :	Xe[^X (YES/NO= }b`Ȃ)
Note    :	
-------------------------------------------------------------------------------*/
int CheckFnameWithArray(LPTSTR filename, LPTSTR mulExp)
{
	int		sts;
	_TCHAR	tmp[MAX_PATH+1+2];

	sts = NO;
	while(*mulExp != NUL)
	{
		/* pX{Ǒ`łȂ̂ _T("*\") Oɕt */
		_tcscpy(tmp, _T(""));
		if(_tcschr(mulExp, _T('\\')) == NULL)
		{
			_tcscat(tmp, _T("*\\"));
		}
		_tcscat(tmp, mulExp);

		if((sts = CheckFname(filename, tmp)) == YES)
		{
			break;
		}
		mulExp += _tcslen(mulExp) + 1;
	}
	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	CheckFname
Desc    :	ChJ[hɃ}b`邩ǂԂ
Param   :	filename	t@C
			exp			ChJ[h
Return  :	Xe[^X (YES/NO= }b`Ȃ)
Note    :	
-------------------------------------------------------------------------------*/
int CheckFname(LPTSTR filename, LPTSTR exp)
{
	int		sts;
	_TCHAR	p1[MAX_PATH+1+2];
	_TCHAR	p2[MAX_PATH+1];
	LPTSTR	p;

	_tcscpy(p1, exp);
	_tcscpy(p2, filename);

//	if(_tcschr(p2, _T('.')) == NULL)
//		_tcscat(p2,_T("."));

	/* *? Ƃ ** Ƃ폜 */
	for(p = p1; *p != NUL; p++)
	{
		while((*p == _T('*')) && ((*(p+1) == _T('?')) || (*(p+1) == _T('*'))))
		{
			_tcscpy(p+1, p+2);
		}
	}

	sts = YES;
	if(_tcscmp(p1, _T("*")) != 0)
	{
		sts = CheckNameMatch(p2, p1);
	}
	return(sts);
}


/*-------------------------------------------------------------------------------
Name    :	CheckNameMatch
Desc    :	ChJ[hTu[`
Param   :	filename	t@C
			exp			ChJ[hi`j
Return  :	Xe[^X (YES/NO= }b`Ȃ)
Note    :	
-------------------------------------------------------------------------------*/
static int CheckNameMatch(LPTSTR filename, LPTSTR exp)
{
	LPTSTR	p;

	for(p = exp; (*p != NUL) && (*filename != NUL); )
	{
		switch(*p)
		{
			case _T('?'):
				filename++;
				p++;
				break;

			case _T('*'):
				/* Look for a character matching the one after the _T('*') */
				p++;
				if(*p == NUL)
				{
					return YES; /* Automatic match */
				}
				while(*filename != NUL)
				{
					while((*filename != NUL) && (_totupper(*p) != _totupper(*filename)))
					{
						filename++;
					}
					if(CheckNameMatch(filename, p))
					{
						return YES;
					}
					if(*filename == NUL)
					{
						return NO;
					}
					else
					{
						filename++;
					}
				}
				return NO;

			default:
				if(_totupper(*filename) != _totupper(*p))
				{
					return NO;
				}
				filename++;
				p++;
				break;
		}
	}

	if((*p == NUL) && (*filename == NUL))
	{
		return YES;
	}

	if ((*p != NUL) && (filename[0] == _T('.')) && (filename[1] == 0))
	{
		return(YES);
	}
  
	if ((*filename == NUL) && (*p == _T('?')))
	{
		while (*p == _T('?'))
		{
			p++;
		}
		return(*p == NUL);
	}

	if((*filename == NUL) && (*p == _T('*')) && (p[1] == _T('\0')))
	{
		return YES;
	}
	return NO;
}


